#include <SM.h>
#include <SPI.h>
#include <Ethernet.h>
#include "Mudbus.h"

Mudbus Mb;

SM Gr7Secu(State10);//creation de la machine "Gr7Secu" et déclaration de State10
//comme l'état initial recevant le pion

SM TWOstates(State0);//creation de la machine "AvancePas" et déclaration de State0
//comme l'état initial recevant le pion
// le nom 2states n'est pas complié

//boutons poussoirs et contacts
#define DCY 3
#define KAU 18 //A4
//electrovannes
#define Tsortie 9// T+ sur la patte PD13, en modbusTCP on ne peut pas utiliser les pin 10,11,12,13

int etat = 0;//variable utilisée pour la détection de front montants
int memo=0;

void setup() {
  uint8_t mac[]     = { 0x90, 0xA2, 0xDA, 0x00, 0x51, 0x06 };
  uint8_t ip[]      = { 192, 168, 1, 44};
  uint8_t gateway[] = { 192, 168, 1, 1 };
  uint8_t subnet[]  = { 255, 255, 255, 0 };
  Ethernet.begin(mac, ip, gateway, subnet);
  //Avoid pins 4,10,11,12,13 when using ethernet shield

  delay(5000);


  pinMode(Tsortie, OUTPUT);//PD13 en sortie
  pinMode(DCY, INPUT);// PD3 en entrée
  pinMode(KAU, INPUT);// PD18 ou A4 en entrée
}

void loop() {
  Mb.Run();
  Mb.R[60] = 12345;//address 40009 in advancedHMI
  memo=Mb.R[8];
   Mb.R[66]=Mb.R[8];
  EXEC(Gr7Secu); //mise en marche de la state machine maitresse: Gr7Secu: un pion est mis dans State10
  //et les séquence peuvent se dérouler.

  if (digitalRead(KAU) == 0) { //Stoppe la machine esclave 2states, (emergency stop)
    digitalWrite(Tsortie, LOW);//faire la remise à zéro des actions associés aux états
    TWOstates.Finish();
  }
  
  if (digitalRead(KAU) == 1 && TWOstates.Finished) { //redémarre la machine esclave AvancePas
    EXEC(TWOstates);            //launch the Master machine
    TWOstates.Set(State0);     //un pion est mis dans l'état initiale State0 de l'esclave
    //quand on acquitte le défaut
  }
}


State State10() {
  digitalWrite(Tsortie, LOW);//T+ mis à 0
  if (digitalRead(KAU) == HIGH) Gr7Secu.Set(State11);//transition de State10 vers State11
}

State State11() {
  EXEC(TWOstates);
  if (digitalRead(KAU) == 0) Gr7Secu.Set(State10);//transition de State10 vers State11
  //si appui sur ATU
}



State State0() {
  digitalWrite(Tsortie, LOW);//T+ mis à 0
  if ((RE(digitalRead(DCY), etat) == 1)|| (RE(memo, etat) == 1)) TWOstates.Set(State1);
  //transition de State0 vers State1 
}

State State1() {
  digitalWrite(Tsortie, HIGH);//T+ mis à 1
  if ((RE(digitalRead(DCY), etat) == 1)|| (RE(memo, etat) == 1)) TWOstates.Set(State0); //transition de State1 vers State2
}

